%# BEGIN BPS TAGGED BLOCK {{{
%#
%# COPYRIGHT:
%#
%# This software is Copyright (c) 1996-2023 Best Practical Solutions, LLC
%#                                          <sales@bestpractical.com>
%#
%# (Except where explicitly superseded by other copyright notices)
%#
%#
%# LICENSE:
%#
%# This work is made available to you under the terms of Version 2 of
%# the GNU General Public License. A copy of that license should have
%# been provided with this software, but in any event can be snarfed
%# from www.gnu.org.
%#
%# This work is distributed in the hope that it will be useful, but
%# WITHOUT ANY WARRANTY; without even the implied warranty of
%# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%# General Public License for more details.
%#
%# You should have received a copy of the GNU General Public License
%# along with this program; if not, write to the Free Software
%# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
%# 02110-1301 or visit their web page on the internet at
%# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html.
%#
%#
%# CONTRIBUTION SUBMISSION POLICY:
%#
%# (The following paragraph is not intended to limit the rights granted
%# to you to modify and distribute this software under the terms of
%# the GNU General Public License and is only of importance to you if
%# you choose to contribute your changes and enhancements to the
%# community by submitting them to Best Practical Solutions, LLC.)
%#
%# By intentionally submitting any modifications, corrections or
%# derivatives to this work, or any other work intended for use with
%# Request Tracker, to Best Practical Solutions, LLC, you confirm that
%# you are the copyright holder for those contributions and you grant
%# Best Practical Solutions,  LLC a nonexclusive, worldwide, irrevocable,
%# royalty-free, perpetual, license to use, copy, create derivative
%# works based on those contributions, and sublicense and distribute
%# those contributions and any derivatives thereof.
%#
%# END BPS TAGGED BLOCK }}}
<& /Admin/Elements/Header, Title => $title &>
<& /Elements/Tabs &>
<& /Elements/ListActions &>

<form action="Objects.html" method="post" name="AddRemoveCustomRole">
<input type="hidden" class="hidden" name="id" value="<% $id %>" />
<input type="hidden" class="hidden" name="From" value="<% $From || q{} %>" />

<h2><&|/l&>Selected objects</&></h2>

<& /Elements/CollectionList,
    OrderBy => 'id',
    Order => 'ASC',
    %ARGS,
    Collection => $added,
    Rows => 0,
    Page => 1,
    Format        => $format,
    DisplayFormat => "'__CheckBox.{RemoveRole-$id}__',". $format,
    AllowSorting => 0,
    ShowEmpty    => 0,
    PassArguments => [
        qw(id Format Rows Page Order OrderBy),
    ],
&>

<h2><&|/l&>Unselected objects</&></h2>

<& /Elements/CollectionList,
    OrderBy => 'Name',
    Order   => 'ASC',
    %ARGS,
    Collection    => $not_added,
    Rows          => $rows,
    Format        => $format,
    DisplayFormat => "'__CheckBox.{AddRole-". $id ."}__',". $format,
    AllowSorting  => 1,
    ShowEmpty     => 0,
    PassArguments => [
        qw(id Format Rows Page Order OrderBy),
    ],
&>

<& /Elements/Submit, Name => 'Update' &>

</form>

<%ARGS>
$id     => undef
$Update => 0
$From   => undef
</%ARGS>
<%INIT>
my $role = RT::CustomRole->new( $session{'CurrentUser'} );
$role->Load($id) or Abort(loc("Could not load custom role #[_1]", $id));
$id = $role->id;

if ($role->Disabled) {
    Abort(loc("Cannot modify objects of disabled custom role #[_1]", $id));
}

if ( $Update ) {
    my (@results);
    if ( defined (my $del = $ARGS{"RemoveRole-$id"}) ) {
        foreach my $id ( ref $del ? (@$del) : ($del) ) {
            my ($status, $msg) = $role->RemoveFromObject( $id );
            push @results, $msg;
        }
    }
    if ( defined (my $add = $ARGS{"AddRole-$id"}) ) {
        foreach my $id ( ref $add ? (@$add) : ($add) ) {
            my ($status, $msg) = $role->AddToObject( $id );
            push @results, $msg;
        }
    }
    MaybeRedirectForResults(
        Actions   => \@results,
        Arguments => {
            id   => $id,
            From => $From,
        },
    );
}

my $added = $role->AddedTo;
my $not_added = $role->NotAddedTo;

my $format = RT->Config->Get('AdminSearchResultFormat')->{'Queues'};
my $rows = RT->Config->Get('AdminSearchResultRows')->{'Queues'} || 50;

my $title = loc('Modify associated objects for [_1]', $role->Name);

</%INIT>
